unit vesa;


interface

var
   xmax:array[0..599] of integer;
   xmin:array[0..599] of integer;
   ymin,ymax:integer;

procedure waitvbl;
procedure SetRGB(n,r,g,b:byte);
procedure SetVESA(mode:word);
procedure setbank(n:word);
procedure vesaputpixel(x,y:longint;color:byte);
procedure ClearScreen;
procedure polyfill(x1,y1,x2,y2,x3,y3,x4,y4:integer;color:byte);

implementation

procedure waitvbl;assembler;
          asm
             mov dx,$3da;@l1:;in al,dx;test al,8;jnz @l1
             @l2:;in al,dx;test al,8;jz @l2
          end;
procedure SetRGB(n,r,g,b:byte);
          begin
               port[$3c8]:=n;
               port[$3c9]:=r;
               port[$3c9]:=g;
               port[$3c9]:=b;
          end;
procedure SetVESA(mode:word);assembler;
          asm mov ax,$4f02;mov bx,mode;int $10
              mov ax,$4f06;mov bx,0;mov cx,2048;int $10
          end;
procedure setbank(n:word);assembler;
          asm
             xor bx,bx;mov dx,n;mov ax,$4f05;int $10
          end;
procedure vesaputpixel(x,y:longint;color:byte);
          begin
               setbank(y shr 6);
               mem[$a000:x+y shl 10]:=color;
          end;
procedure ClearScreen;assembler;
          asm xor bx,bx;mov dx,0;mov ax,$a000;mov es,ax
          @loop1:
             mov ax,$4f05;int $10;xor di,di;mov cx,16384;db $66;xor ax,ax
             db $66;rep stosw;inc dx;cmp dx,10;jne @loop1
          end;
procedure polyfill(x1,y1,x2,y2,x3,y3,x4,y4:integer;color:byte);
procedure hline(x1,y1,x2,y2:integer);
          var
          temp:integer;
          deltax:single;
          y:integer;
          x:single;
          begin
               if y1=y2 then exit;
               if y1>y2 then begin
                  temp:=y1;y1:=y2;y2:=temp;temp:=x1;x1:=x2;x2:=temp;end;
               deltax:=(x2-x1)/(y2-y1);
               x:=x1;
               for y:=y1 to y2 do begin
                   temp:=round(x);
                   if temp>xmax[y] then xmax[y]:=temp;
                   if temp<xmin[y] then xmin[y]:=temp;
                   x:=x+deltax;
               end;
          end;
var
   i,y:integer;
   temp:word;
   bank:byte;
   xx1,xx2:word;
begin
     ymin:=y1;
     ymax:=y1;
     if y2>ymax then ymax:=y2;
     if y3>ymax then ymax:=y3;
     if y4>ymax then ymax:=y4;
     if y2<ymin then ymin:=y2;
     if y3<ymin then ymin:=y3;
     if y4<ymin then ymin:=y4;

     for i:=ymin to ymax do begin
         xmax[i]:=-maxint;
         xmin[i]:=maxint;
     end;


     hline(x1,y1,x2,y2);
     hline(x2,y2,x3,y3);
     hline(x3,y3,x4,y4);
     hline(x4,y4,x1,y1);
     bank:=ymin shr 6;
     setbank(bank);
     for y:=ymin to ymax do
         begin
              if (y shr 6)>bank then begin inc(bank);setbank(bank);end;
              xx1:=xmin[y];
              xx2:=xmax[y];
              asm
                 mov ax,$a000;mov es,ax;mov cx,xx2;sub cx,xx1;inc cx;mov dx,cx
                 shr cx,2;mov di,y;shl di,10;add di,xx1;mov al,color
                 mov ah,al;db $66;shl ax,16;mov al,color;mov ah,al
                 db $66;rep stosw;mov cx,dx;and cx,3;rep stosb
              end;
         end;
end;






begin

end.