{$S-} {$R-} {$Q-}
{ Stack    checking OFF
  Range    checking OFF
  Overflow checking OFF }
unit _320_200;

interface
var
   apage,vpage:byte;
procedure initgraph;
procedure closegraph;
procedure cls;
procedure waitvbl;
procedure copytoekran;

procedure bar(x1,y1,x2,y2:integer;renk:byte);
procedure rectangle(x1,y1,x2,y2:integer;renk:byte);

procedure getimage(x1,y1,x2,y2:integer;var buffer);
procedure putimage(x,y:integer;var buffer);

implementation
uses dos;

procedure initgraph;
var
   r:registers;
begin
r.ah:=0;
r.al:=$13;
intr($10,r);
end;

procedure closegraph;
var
   r:registers;
begin
r.ah:=0;
r.al:=3;
intr($10,r);
end;

procedure cls;
begin
fillchar(mem[$a000+apage:0],64000,#0);
end;

procedure waitvbl;
begin
repeat until port[$3da]=13;
end;

procedure copytoekran;
begin
if apage<>0 then move(mem[$a000+apage:0],mem[$a000:0],64000);
end;

procedure bar(x1,y1,x2,y2:integer;renk:byte);
var
   i0:integer;
begin
for i0:=y1 to y2 do fillchar(mem[$a000+apage:i0*320+x1],x2-x1+1,chr(renk));
end;

procedure rectangle(x1,y1,x2,y2:integer;renk:byte);
var
   i0:integer;
begin
fillchar(mem[$a000+apage:y1*320+x1],x2-x1+1,chr(renk));
for i0:=y1 to y2 do
begin
  mem[$a000+apage:i0*320+x1]:=renk;
  mem[$a000+apage:i0*320+x2]:=renk;
end;
fillchar(mem[$a000+apage:y2*320+x1],x2-x1+1,chr(renk));
end;

procedure getimage(x1,y1,x2,y2:integer;var buffer);
var
   i0:integer;
begin
for i0:=y1 to y2 do move(mem[$a000+apage:320*y1+x1],addr(buffer)^,x2-x1+1);
end;

procedure putimage(x,y:integer;var buffer);
var
   i0:integer;
begin
for i0:=y1 to y2 do move(addr(buffer)^,mem[$a000+apage:320*y1+x1],x2-x1+1);
end;

function imagesize(x1,y1,x2,y2:integer):word;
begin
imagesize:=320*(y2-y1+1)+(begin
apage:=0;
vpage:=0;
end.
